/* -*- c++ -*-
FILE: MagicCube4d.cpp
RCS REVISION: $Revision: 1.8 $

COPYRIGHT: (c) 1999 -- 2003 Melinda Green, Don Hatch, and Jay Berkenbilt - Superliminal Software

LICENSE: Free to use and modify for non-commercial purposes as long as the
    following conditions are adhered to:
    1) Obvious credit for the source of this code and the designs it embodies
       are clearly made, and
    2) Ports and derived versions of 4D Magic Cube programs are not distributed
       without the express written permission of the authors.

DESCRIPTION:
    MagicCube4d.cpp : Defines the class behaviors for the application.
*/

#include "Stdafx.h"
#include "MagicCube4d.h"

#include "MainFrm.h"
#include "MagicCube4dDoc.h"
#include "MagicCube4dView.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMagicCube4dApp

BEGIN_MESSAGE_MAP(CMagicCube4dApp, CWinApp)
    //{{AFX_MSG_MAP(CMagicCube4dApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
        // NOTE - the ClassWizard will add and remove mapping macros here.
        //    DO NOT EDIT what you see in these blocks of generated code!
    //}}AFX_MSG_MAP
    // Standard file based document commands
    ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMagicCube4dApp construction

CMagicCube4dApp::CMagicCube4dApp()
{
    // TODO: add construction code here,
    // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMagicCube4dApp object

CMagicCube4dApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMagicCube4dApp initialization

BOOL
CMagicCube4dApp::InitInstance()
{
    // Standard initialization
    // If you are not using these features and wish to reduce the size
    // of your final executable, you should remove from the following
    // the specific initialization routines you do not need.

#ifdef _AFXDLL
    Enable3dControls();         // Call this when using MFC in a shared DLL
#else
    Enable3dControlsStatic();   // Call this when linking to MFC statically
#endif

    LoadStdProfileSettings();   // Load standard INI file options (including
                                // MRU)

    // Register the application's document templates.  Document templates
    // serve as the connection between documents, frame windows and views.

    CSingleDocTemplate* pDocTemplate;
    pDocTemplate = new CSingleDocTemplate
        (IDR_MAINFRAME,
         RUNTIME_CLASS(CMagicCube4dDoc),
         RUNTIME_CLASS(CMainFrame),       // main SDI frame window
         RUNTIME_CLASS(CMagicCube4dView));
    AddDocTemplate(pDocTemplate);

    // Parse command line for standard shell commands, DDE, file open
    CCommandLineInfo cmdInfo;
    ParseCommandLine(cmdInfo);

    // Dispatch commands specified on the command line
    if (!ProcessShellCommand(cmdInfo))
        return FALSE;

    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    // {{AFX_VIRTUAL(CAboutDlg)
protected:
    virtual void
    DoDataExchange(CDataExchange * pDX);    // DDX/DDV support
    // }}AFX_VIRTUAL

// Implementation
protected:
    // {{AFX_MSG(CAboutDlg)
    // No message handlers
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    // {{AFX_DATA_INIT(CAboutDlg)
    // }}AFX_DATA_INIT
}

void
CAboutDlg::DoDataExchange(CDataExchange * pDX)
{
    CDialog::DoDataExchange(pDX);
    // {{AFX_DATA_MAP(CAboutDlg)
    // }}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
    // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void
CMagicCube4dApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMagicCube4dApp commands

BOOL
CMagicCube4dApp::OnIdle(LONG lCount)
{
    // TODO: Add your specialized code here and/or call the base class

    // Let the base class do anything it may need to first
    //
    CWinApp::OnIdle(lCount);

    // assert(m_pMainWnd &&
    // m_pMainWnd->IsKindOf(RUNTIME_CLASS(CMagicCube4dWnd)));
    CView      *
        pView = ((CFrameWnd *) m_pMainWnd)->GetActiveView();
    assert(pView && pView->IsKindOf(RUNTIME_CLASS(CMagicCube4dView)));
    CMagicCube4dView *
        mcview = (CMagicCube4dView *) pView;

    return mcview->Update3d();
}

// Local Variables:
// c-basic-offset: 4
// c-comment-only-line-offset: 0
// c-file-offsets: ((defun-block-intro . +) (block-open . 0) (substatement-open . 0) (statement-cont . +) (statement-case-open . +4) (arglist-intro . +) (arglist-close . +) (inline-open . 0))
// indent-tabs-mode: nil
// End:
